#!----------------------------------------------------------------------------!
#Template (MyTemplateChain,'My custom template chain'),FAMILY('MyTemplate')
#!----------------------------------------------------------------------------!
#System
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! Declare your global template variables with #Declare
#!---------------------------------------------------------------------
#Declare(%SourceFile)
#Declare(%GenerateModule)
#Declare(%GlobalRegenerate)
#Declare(%BuildFile)
#Declare(%BuildHeader)
#!---------------------------------------------------------------------
#Application('Custom application')
#!---------------------------------------------------------------------
#! Do any setup for the global template prompts here. 
#!---------------------------------------------------------------------
#Prepare
#Insert(%Trace,'#APPLICATION #Prepare')
#EndPrepare
#Sheet,ADJUST
    #Tab('General')
        #Display('Add your general settings here')
    #EndTab
#EndSheet
#!---------------------------------------------------------------------
#! Begin code generation
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! For some reason generation messages don't appear in C7 unless there's 
#! an #Error statement at the start. 
#!---------------------------------------------------------------------
#Error(' ') 
#Insert(%Trace,'Generating ' & %Application & ' global data')            #! Open the Message Box
#Set(%BuildFile,Upper(%Application&'.B1$'))
#Set(%BuildHeader,Upper(%Application&'.H1$'))
#If (%EditProcedure)                                #! Special case for editing embedded source in context
    #Insert(%Trace,'Generating ' & %EditFilename & ' for embeditor')
    #Create(%EditFilename)
    #FIND(%ModuleProcedure,%EditProcedure)
    #Fix(%Procedure,%ModuleProcedure)                 #! Fix current procedure
    #! #Message('Generating Module:    ' & %Module,1)    #! Post generation message
    #! #Message('Generating Procedure: ' & %Procedure,2) #! Post generation message
    #Generate(%Procedure)                             #! Generate procedure code
    #Comment(60)                                      #!Set comment alignment to column 60
    #Close
    #! Terminate code generation if this is just an embed edit
    #Abort        
#EndIf
#!---------------------------------------------------------------------
#! This is the standard Clarion approach
#!---------------------------------------------------------------------
#Comment(60)                                  #! Set comment alignment to column 60
#For(%Module),Where (%Module <> %Program)        #! For all member modules
  #Insert(%Trace,'Checking module ' & %Module)
  #If(~%ConditionalGenerate Or %GlobalRegenerate Or %ModuleChanged Or ~FILEEXISTS(%Module))
    #Set(%GenerateModule,%True)
  #Else
    #Set(%GenerateModule,%False)
  #EndIf
  #If(%GenerateModule)                            #! IF module to be generated
    #Insert(%Trace,'Generating module ' & %Module)
    #Generate(%Module)
  #EndIf                                          #! END (If module to be...)
#EndFor     
#!---------------------------------------------------------------------
#! Generate the procedures
#!---------------------------------------------------------------------
#!#For(%Module),Where (%Module <> %Program) 
#!    #Insert(%Trace,'Checking module ' & %Module)
#!    #If(%ModuleChanged)
#!        #Insert(%Trace,'Module has changed, generating')
#!        #For(%ModuleProcedure)
#!            #Fix(%Procedure,%ModuleProcedure)
#!            #Message('Generating ' & %Procedure,2)        
#!            #Set(%SourceFile,%Application & '.' & %Procedure & '.txt')
#!            #Insert(%Trace,'Creating file ' & %SourceFile)
#!            #CREATE(%SourceFile)
#!            #GENERATE(%Procedure)
#!            #CLOSE(%SourceFile)
#!        #EndFor
#!    #Else
#!        #Insert(%Trace,'Module unchanged, not generating')
#!    #EndIf
#!#EndFor
#!---------------------------------------------------------------------
#! End code generation
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! Includes
#!---------------------------------------------------------------------
#INCLUDE('my_standard.tpw')
#INCLUDE('my_groups.tpw')
#INCLUDE('my_procedures.tpw')
#Include('my_extensions.tpw')